
# Génération de documents

## Syntaxe de génération d'un document

## Principes liés au variables

### Nommage de variables

Les variables rendues disponibles sont composées de plusieurs champs. Par exemple, à chaque fois qu'un usager est évoqué, les variables suivantes sont disponibles:

* userName;
* userService;
* …

Ces variables peuvent être préfixées par une autre variable. Par exemple, l'utilisateur qui crée un document est un `creator`. Les différentes variables accessibles sont donc:

* `creatorUserName`;
* `creatorService`;
* …

Le camel-case est la syntaxe utilisée pour la composition des noms de variable.

### Cas où une variable peut être de deux natures différente

Certaines variables peuvent être de deux natures différentes, par exemple, soit une personne, soit un tiers. Dans ce cas, les variables qui sont de noms différents sont à l'état "vide". Par exemple, le champ "date de naissance" n'est pas disponible pour un tiers, dans ce cas, il est vide.

Exemple, une liste des interlocuteurs principaux. Le premier est une personne:

```
text=Maxime Berger
firstName=Maxime
lastName=Berger
birthDate=19/01/1996
type=
```

Le second est un tiers:

```
text=Jean Couteau
firstName=Jean
lastName=Couteau
birthDate=
type=Médecin
```

## Variables disponibles

### Pour chaque document

* `creator`: (User) le créateur
* `createDate`: la date de création, au formation jj/mm/dd
* `locate`: le lieu sélectionné par le créateur, au moment de la génération

### Document générés pour un parcours

* `coursePersons`: une liste des personnes du parcours
* `courseStartDate`: la date de confirmation du parcours
* `courseRef`: (User): le référent du parcours;
* `courseLocation` (Adresse): l'adresse de localisation du parcours
* `coursePersonLocation` (Person): l'utilisateur qui localise le parcours (s'il y en a un, peut être vide);
* `courseRequestor` (Person ou ThirdParty): le demandeur. Peut être vide.
* `courseResources` (Person ou ThirdParty): une liste des interlocuteurs privilégiés


